from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, String, Boolean

Dfgeval_V0_1_0 = CommandToolBuilder(tool="dfgEval", base_command=["dfgEval"], inputs=[ToolInput(tag="in_arg_calculate_posterior", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="[ --ppFile ] arg                   Calculate posterior probabilities for\neach state of each random variable and\noutput to file.")), ToolInput(tag="in_arg_calculate_normalization", input_type=File(optional=True), prefix="-n", doc=InputDocumentation(doc="[ --ncFile ] arg                   Calculate normalization constant output\nto file.")), ToolInput(tag="in_arg_calculate_state", input_type=File(optional=True), prefix="-m", doc=InputDocumentation(doc="[ --mpsFile ] arg                  Calculate most probable state for each\nrandom variable and output to file.")), ToolInput(tag="in_exp_file", input_type=String(optional=True), prefix="--expFile", doc=InputDocumentation(doc="Calculate expectancies and output to")), ToolInput(tag="in_pp_sum_other", input_type=Boolean(optional=True), prefix="--ppSumOther", doc=InputDocumentation(doc="For post probs, for each state output\nsum of post probs for all the other\nstates for that variable. This retains\nprecision for post probs very close to\none.")), ToolInput(tag="in_output_natural_logarithm", input_type=Boolean(optional=True), prefix="-l", doc=InputDocumentation(doc="[ --minusLogarithm ]               Output minus the natural logarithm of\nresult values (program will terminate\non negative results...).")), ToolInput(tag="in_mps_vars", input_type=String(optional=True), prefix="--mpsVars", doc=InputDocumentation(doc="Define the random variables for which\nthe most probable state (mps) should be\noutput. Default is to output the mps\nfor all random variables. The\nspecification string must be enclosed\nin citation marks and whitespace\nseparated if it includes more than one\nrandom variable, e.g.: 'X Y'.")), ToolInput(tag="in_pp_vars", input_type=String(optional=True), prefix="--ppVars", doc=InputDocumentation(doc="Define the random variables for which\nthe posterior state probabilities (pp)\nshould be calculated. Default is to\noutput the pp for all states of all\nrandom variables (may generate much\noutput!). Random variables are\nspecified similar to mpsVars, but must\nbe semicolon (';') separated. It is\npossible to only output pp's for\ncertain states, in which case the\nfollowing specification format is used:\n'X=a b c; Y=a b'.")), ToolInput(tag="in_arg_dfgspecprefix_dfg", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc="[ --dfgSpecPrefix ] arg (=./dfgSpec/)\nPrefix of DFG specification files..")), ToolInput(tag="in_factor_graph_file", input_type=String(optional=True), prefix="--factorGraphFile", doc=InputDocumentation(doc="(=factorGraph.txt)\nSpecification of the factor graph\nstructure.")), ToolInput(tag="in_variables_file", input_type=String(optional=True), prefix="--variablesFile", doc=InputDocumentation(doc="(=variables.txt)  Specification of the state map used by\neach variable.")), ToolInput(tag="in_state_map_file", input_type=String(optional=True), prefix="--stateMapFile", doc=InputDocumentation(doc="(=stateMaps.txt)   Specification of state maps.")), ToolInput(tag="in_fac_pot_file", input_type=String(optional=True), prefix="--facPotFile", doc=InputDocumentation(doc="(=factorPotentials.txt)\nSpecification of factor potentials.")), ToolInput(tag="in_sub_var_file", input_type=File(optional=True), prefix="--subVarFile", doc=InputDocumentation(doc="Input subscribed variables file in\nnamed data format. Must use same\nidentifiers in same order as varFile\n")), ToolInput(tag="in_file", input_type=File(), position=0, doc=InputDocumentation(doc="-p [ --precision ] arg (=5)           Output precision of real numbers."))], outputs=[ToolOutput(tag="out_arg_calculate_posterior", output_type=File(optional=True), selector=InputSelector(input_to_select="in_arg_calculate_posterior", type_hint=File()), doc=OutputDocumentation(doc="[ --ppFile ] arg                   Calculate posterior probabilities for\neach state of each random variable and\noutput to file.")), ToolOutput(tag="out_arg_calculate_normalization", output_type=File(optional=True), selector=InputSelector(input_to_select="in_arg_calculate_normalization", type_hint=File()), doc=OutputDocumentation(doc="[ --ncFile ] arg                   Calculate normalization constant output\nto file.")), ToolOutput(tag="out_arg_calculate_state", output_type=File(optional=True), selector=InputSelector(input_to_select="in_arg_calculate_state", type_hint=File()), doc=OutputDocumentation(doc="[ --mpsFile ] arg                  Calculate most probable state for each\nrandom variable and output to file."))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Dfgeval_V0_1_0().translate("wdl", allow_empty_container=True)

